/* GCC */

#include <fstream>
#include <vector>
#define LONG unsigned long long

using namespace std;

struct Rect
{
     LONG X, Y, Width, Height;
     bool Rot;
     void ChangeRot()
     {
          Rot = !Rot;
          LONG tmp = Width;
          Width = Height;
          Height = tmp;   
     }
};

struct Lamana
{
      LONG X[100], Y[100];
      int Count;     
      vector<int> usedRects;
      bool Contains(int r)
      {
          for(int i = 0; i < usedRects.size(); i++)
              if(usedRects[i] == r)
                   return true;
          return false; 
      }
};

Rect Rects[16];
Rect BigRect;

int n;
int Solutions = 0;

ifstream fin;
ofstream fout;

inline bool CheckSqrs()
{
       LONG sum = 0;
       for(int i = 0; i < n; i++)
               sum += Rects[i].Width*Rects[i].Height;
       return sum == BigRect.Width*BigRect.Height;       
}

inline void Save()
{
       int vals[16];
       vector<int> res(n);
       bool ignored[16];
       
       for(int i = 0; i < n; i++)
       {
           vals[i] = 1000*Rects[i].X;
           vals[i] += 100*Rects[i].Y;
           vals[i] += 10*i;
           vals[i] += Rects[i].Rot;
           ignored[i] = false;
       }
       
       for(int i = 0; i < n; i++)
       {
               int ind = -1;
               for(int k = 0; k < n; k++)
               {
                   if(ignored[k])
                       continue;
                   if(ind == -1)
                   {
                       ind = k;    
                   }   
                   else if(vals[k] < vals[ind])
                   {
                       ind = k;    
                   }   
               }
          ignored[ind] = true;
          fout<<Rects[ind].X<<' '<<Rects[ind].Y<<' '
          <<ind+1<<' '<<Rects[ind].Rot;
          if(i != n-1)
              fout<<' ';
       }
       
       fout<<endl;
       Solutions++;
}

inline void Fail()
{
       fout<<"No Solution"<<endl;
       fout.close();       
}

inline void Simplify(Lamana &lamana)
{
       for(int i = 2; i < lamana.Count; i++)
       {
           if((lamana.X[i-2] == lamana.X[i-1] && lamana.X[i-1] == lamana.X[i]) ||
              (lamana.Y[i-2] == lamana.Y[i-1] && lamana.Y[i-1] ==lamana.Y[i]))
           {
              lamana.Count--;
              for(int k = i-1; k < lamana.Count; k++)
              {
                  lamana.X[k] = lamana.X[k+1];
                  lamana.Y[k] = lamana.Y[k+1];
              }
           }      
       }
              
}

inline bool Primostiti(Lamana &lamana, int r)
{      
       int index;
       for(int i = 1; i < lamana.Count -1; i++)
       {
               if(lamana.Y[i]!=BigRect.Height)
               {
                      index = i;
                      break;
               }
       }
       
       if(lamana.X[index] + Rects[r].Width > BigRect.Width ||
          lamana.Y[index] + Rects[r].Height > BigRect.Height)
          return false;
       
       for(int i = lamana.Count-1; i >= index; i--)
       {
               lamana.X[i+2] = lamana.X[i];
               lamana.Y[i+2] = lamana.Y[i];        
       }
       
       Rects[r].X = lamana.X[index];
       Rects[r].Y = lamana.Y[index];
       lamana.Count += 2;
       lamana.X[index+2] = lamana.X[index] + Rects[r].Width;
       lamana.Y[index+2] = lamana.Y[index];
       lamana.Y[index] += Rects[r].Height;
       lamana.X[index+1] = lamana.X[index] + Rects[r].Width;
       lamana.Y[index+1] = lamana.Y[index];
       
       lamana.usedRects.push_back(r);
       
       return true;
}

inline void Step(Lamana lamana)
{
       if(lamana.usedRects.size() == n)
       {
           Save();
           return;                           
       }
           
       Lamana tmp;
       for(int i = 0; i < n; i++)
       {
               if(lamana.Contains(i))
                   continue;
               
               tmp = lamana;
               if(Primostiti(tmp, i))
               {
                   Simplify(tmp);
                   Step(tmp);                      
               }
               
               tmp = lamana;
               Rects[i].ChangeRot();
               if(Primostiti(tmp, i))
               {
                   Simplify(tmp);
                   Step(tmp);                      
               }
               Rects[i].ChangeRot();
       }
}

int main()
{
    fin.open("rectang.in");
    fin>>n;
    for(int i = 0; i < n; i++)
    {
        fin>>Rects[i].Width>>Rects[i].Height;
        Rects[i].Rot = false;    
    }
    fin>>BigRect.Width>>BigRect.Height;
    fin.close();
    
    fout.open("rectang.out");
    if(!CheckSqrs())
    {
       Fail();
       return 0;   
    }
    
    Lamana lamana;
    lamana.X[0] = 0; lamana.X[1] = 0; lamana.X[2] = BigRect.Width;
    lamana.Y[0] = BigRect.Height; lamana.Y[1] = 0; lamana.Y[2] = 0;
    lamana.Count = 3;
    
    
    Step(lamana);
    if(!Solutions)
    {
        Fail();
        return 0;
    }
    fout.close();
}
